Index: tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.energy.all
===================================================================
--- tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.energy.all	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.energy.all	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,2 @@
+Time		Total
+0.000000e+00	-39.9767398341
Index: tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.energyfragment.all
===================================================================
--- tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.energyfragment.all	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.energyfragment.all	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,2 @@
+Time		Total
+0.000000e+00	-3.997674e+01	
Index: tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.forcefragment.all
===================================================================
--- tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.forcefragment.all	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.forcefragment.all	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,6 @@
+Type	No		Pos0		Pos1		Pos2		Total0		Total1		Total2
+0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	
+0.000000e+00	1.000000e+00	3.389977e+00	3.758651e+00	4.280000e+00	-1.218400e-06	2.942377e-03	4.166006e-03	
+0.000000e+00	2.000000e+00	3.389977e+00	3.758651e+00	2.500000e+00	-1.218400e-06	2.942377e-03	-4.166006e-03	
+0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	0.000000e+00	
+1.000000e+00	0.000000e+00	3.389977e+00	3.129351e+00	3.390000e+00	2.666300e-06	2.691600e-06	0.000000e+00	
Index: tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.forces.all
===================================================================
--- tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.forces.all	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.forces.all	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,121 @@
+Type	No		Pos0		Pos1		Pos2		Total0		Total1		Total2
+0	0	4.279931075	2.500000000	3.390000000	0.0041554983	-0.0029446206	0.0000000000
+0	1	3.389977412	3.758650838	4.280000000	-0.0000012184	0.0029423768	0.0041660062
+0	2	3.389977412	3.758650838	2.500000000	-0.0000012184	0.0029423768	-0.0041660062
+0	3	2.500000000	2.500033583	3.390000000	-0.0041557279	-0.0029428245	0.0000000000
+1	0	3.389977412	3.129350838	3.390000000	0.0000026663	0.0000026916	-0.0000000000
+MeanForce:	0.00407792474624
+0	0	4.279931075	2.500000000	3.390000000	0.0041554988	-0.0029446210	0.0000000000
+0	1	3.389977412	3.758650838	4.280000000	-0.0000012184	0.0029423771	0.0041660067
+0	2	3.389977412	3.758650838	2.500000000	-0.0000012184	0.0029423771	-0.0041660067
+0	3	2.500000000	2.500033583	3.390000000	-0.0041557284	-0.0029428249	0.0000000000
+1	0	3.389977412	3.129350838	3.390000000	0.0000026663	0.0000026916	-0.0000000000
+MeanForce:	0.00407792523452
+0	0	4.279931075	2.500000000	3.390000000	0.0043444027	-0.0030510304	-0.0000460536
+0	1	3.389977412	3.758650838	4.280000000	-0.0001366812	0.0041078348	0.0056397250
+0	2	3.389977412	3.758650838	2.500000000	-0.0006074432	0.0028862577	-0.0044788181
+0	3	2.500000000	2.500033583	3.390000000	-0.0050957307	-0.0030556661	-0.0005197858
+1	0	3.389977412	3.129350838	3.390000000	0.0014954524	-0.0008873959	-0.0005950676
+MeanForce:	0.00509049890888
+0	0	4.279931075	2.500000000	3.390000000	0.0030535495	-0.0025235115	-0.0002706606
+0	1	3.389977412	3.758650838	4.280000000	-0.0006897713	0.0020139568	0.0026554325
+0	2	3.389977412	3.758650838	2.500000000	-0.0002519082	0.0037312487	-0.0051807902
+0	3	2.500000000	2.500033583	3.390000000	-0.0069037688	-0.0045745522	0.0001750117
+1	0	3.389977412	3.129350838	3.390000000	0.0047918987	0.0013528581	0.0026210067
+MeanForce:	0.00553482248962
+0	0	4.279931075	2.500000000	3.390000000	0.0040830727	-0.0036386948	-0.0000643415
+0	1	3.389977412	3.758650838	4.280000000	-0.0003111500	0.0024361607	0.0033033846
+0	2	3.389977412	3.758650838	2.500000000	-0.0003484805	0.0033140815	-0.0047085341
+0	3	2.500000000	2.500033583	3.390000000	-0.0022110597	-0.0018452600	-0.0000978722
+1	0	3.389977412	3.129350838	3.390000000	-0.0012123825	-0.0002662874	0.0015673631
+MeanForce:	0.00404703661547
+0	0	4.279931075	2.500000000	3.390000000	0.0031942281	-0.0019460955	0.0004940717
+0	1	3.389977412	3.758650838	4.280000000	-0.0000180300	0.0044251344	0.0059426797
+0	2	3.389977412	3.758650838	2.500000000	-0.0001693778	0.0045931593	-0.0053288501
+0	3	2.500000000	2.500033583	3.390000000	-0.0032616227	-0.0018631250	0.0003443222
+1	0	3.389977412	3.129350838	3.390000000	0.0002548024	-0.0052090732	-0.0014522236
+MeanForce:	0.00548101712183
+0	0	4.279931075	2.500000000	3.390000000	0.0077963079	-0.0054205802	-0.0000036586
+0	1	3.389977412	3.758650838	4.280000000	0.0001017687	0.0026897526	0.0038147124
+0	2	3.389977412	3.758650838	2.500000000	0.0002597171	0.0032618199	-0.0044748217
+0	3	2.500000000	2.500033583	3.390000000	-0.0037617795	-0.0028248268	0.0001526926
+1	0	3.389977412	3.129350838	3.390000000	-0.0043960142	0.0022938344	0.0005110754
+MeanForce:	0.00587987613927
+0	0	4.279931075	2.500000000	3.390000000	0.0040481840	-0.0025387273	-0.0003537720
+0	1	3.389977412	3.758650838	4.280000000	0.0003552458	0.0022664835	0.0020830649
+0	2	3.389977412	3.758650838	2.500000000	0.0000721214	0.0047346219	-0.0065580596
+0	3	2.500000000	2.500033583	3.390000000	-0.0033995007	-0.0023827826	-0.0006395737
+1	0	3.389977412	3.129350838	3.390000000	-0.0010760505	-0.0020795954	0.0054683404
+MeanForce:	0.00522561039735
+0	0	4.279931075	2.500000000	3.390000000	0.0041591583	-0.0029696721	0.0000030964
+0	1	3.389977412	3.758650838	4.280000000	-0.0001225325	0.0035968092	0.0041359050
+0	2	3.389977412	3.758650838	2.500000000	-0.0000619976	0.0018103049	-0.0015569083
+0	3	2.500000000	2.500033583	3.390000000	-0.0040720513	-0.0027770739	0.0000623552
+1	0	3.389977412	3.129350838	3.390000000	0.0000974230	0.0003396320	-0.0026444483
+MeanForce:	0.00411575147167
+0	0	4.279931075	2.500000000	3.390000000	0.0038278415	-0.0033818440	0.0001418685
+0	1	3.389977412	3.758650838	4.280000000	0.0002192977	0.0038747670	0.0051308398
+0	2	3.389977412	3.758650838	2.500000000	-0.0000204468	0.0031980123	-0.0041292848
+0	3	2.500000000	2.500033583	3.390000000	-0.0052220037	-0.0045125367	-0.0000973137
+1	0	3.389977412	3.129350838	3.390000000	0.0011953112	0.0008216014	-0.0010461098
+MeanForce:	0.00509131548224
+0	0	4.279931075	2.500000000	3.390000000	0.0044613842	-0.0032981168	0.0006657318
+0	1	3.389977412	3.758650838	4.280000000	0.0003380963	0.0015162223	0.0026196160
+0	2	3.389977412	3.758650838	2.500000000	-0.0005115769	0.0023708475	-0.0033571557
+0	3	2.500000000	2.500033583	3.390000000	-0.0051982590	-0.0036959697	-0.0001890792
+1	0	3.389977412	3.129350838	3.390000000	0.0009103554	0.0031070167	0.0002608870
+MeanForce:	0.00448086362631
+0	0	4.279931075	2.500000000	3.390000000	0.0039655920	-0.0028376411	0.0000468186
+0	1	3.389977412	3.758650838	4.280000000	0.0001303199	0.0017630577	0.0026691443
+0	2	3.389977412	3.758650838	2.500000000	0.0006028581	0.0030000806	-0.0038563849
+0	3	2.500000000	2.500033583	3.390000000	-0.0032151883	-0.0028249918	0.0005162826
+1	0	3.389977412	3.129350838	3.390000000	-0.0014835817	0.0008994946	0.0006241393
+MeanForce:	0.00383115724708
+0	0	4.279931075	2.500000000	3.390000000	0.0052502375	-0.0033546379	0.0002722412
+0	1	3.389977412	3.758650838	4.280000000	0.0006994572	0.0038607258	0.0056616274
+0	2	3.389977412	3.758650838	2.500000000	0.0002448590	0.0021485037	-0.0031434246
+0	3	2.500000000	2.500033583	3.390000000	-0.0013277381	-0.0012427022	-0.0001745796
+1	0	3.389977412	3.129350838	3.390000000	-0.0048668156	-0.0014118893	-0.0026158645
+MeanForce:	0.00489396240823
+0	0	4.279931075	2.500000000	3.390000000	0.0042273839	-0.0022527419	0.0000631438
+0	1	3.389977412	3.758650838	4.280000000	0.0003115948	0.0034429731	0.0050212445
+0	2	3.389977412	3.758650838	2.500000000	0.0003453161	0.0025680261	-0.0036213692
+0	3	2.500000000	2.500033583	3.390000000	-0.0060718635	-0.0040182803	0.0001006106
+1	0	3.389977412	3.129350838	3.390000000	0.0011875687	0.0002600230	-0.0015636296
+MeanForce:	0.00492042081446
+0	0	4.279931075	2.500000000	3.390000000	0.0051019087	-0.0039381310	-0.0005035725
+0	1	3.389977412	3.758650838	4.280000000	0.0000142417	0.0014276153	0.0023368390
+0	2	3.389977412	3.758650838	2.500000000	0.0001647878	0.0012889180	-0.0029828840
+0	3	2.500000000	2.500033583	3.390000000	-0.0050373996	-0.0040209292	-0.0003514439
+1	0	3.389977412	3.129350838	3.390000000	-0.0002435385	0.0052425270	0.0015010615
+MeanForce:	0.00487406922734
+0	0	4.279931075	2.500000000	3.390000000	0.0003652370	-0.0003579995	0.0000036880
+0	1	3.389977412	3.758650838	4.280000000	-0.0001067830	0.0031966655	0.0045173977
+0	2	3.389977412	3.758650838	2.500000000	-0.0002623345	0.0026253274	-0.0038592399
+0	3	2.500000000	2.500033583	3.390000000	-0.0045505162	-0.0030585485	-0.0001534456
+1	0	3.389977412	3.129350838	3.390000000	0.0045543967	-0.0024054449	-0.0005084002
+MeanForce:	0.00427641715712
+0	0	4.279931075	2.500000000	3.390000000	0.0042699101	-0.0033584820	0.0003575535
+0	1	3.389977412	3.758650838	4.280000000	-0.0003626288	0.0035872685	0.0062333853
+0	2	3.389977412	3.758650838	2.500000000	-0.0000700768	0.0010902902	-0.0016884717
+0	3	2.500000000	2.500033583	3.390000000	-0.0049108814	-0.0035061248	0.0006473271
+1	0	3.389977412	3.129350838	3.390000000	0.0010736769	0.0021870481	-0.0055497942
+MeanForce:	0.00535721414943
+0	0	4.279931075	2.500000000	3.390000000	0.0041522840	-0.0029209271	-0.0000018686
+0	1	3.389977412	3.758650838	4.280000000	0.0001196220	0.0022902215	0.0041901891
+0	2	3.389977412	3.758650838	2.500000000	0.0000607726	0.0040326094	-0.0067308789
+0	3	2.500000000	2.500033583	3.390000000	-0.0042401346	-0.0031101062	-0.0000619770
+1	0	3.389977412	3.129350838	3.390000000	-0.0000925440	-0.0002917976	0.0026045355
+MeanForce:	0.00511628835338
+0	0	4.279931075	2.500000000	3.390000000	0.0044862365	-0.0025089762	-0.0001420980
+0	1	3.389977412	3.758650838	4.280000000	-0.0002224848	0.0020007189	0.0031898348
+0	2	3.389977412	3.758650838	2.500000000	0.0000175759	0.0026860675	-0.0042027960
+0	3	2.500000000	2.500033583	3.390000000	-0.0030637741	-0.0013626548	0.0000985235
+1	0	3.389977412	3.129350838	3.390000000	-0.0012175535	-0.0008151555	0.0010565358
+MeanForce:	0.0038125856326
+0	0	4.279931075	2.500000000	3.390000000	0.0038505269	-0.0025911312	-0.0006621881
+0	1	3.389977412	3.758650838	4.280000000	-0.0003415139	0.0043522158	0.0056815787
+0	2	3.389977412	3.758650838	2.500000000	0.0005137051	0.0035083981	-0.0049679242
+0	3	2.500000000	2.500033583	3.390000000	-0.0030983107	-0.0021804935	0.0001879456
+1	0	3.389977412	3.129350838	3.390000000	-0.0009244074	-0.0030889892	-0.0002394121
+MeanForce:	0.00499667298065
Index: tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.speed
===================================================================
--- tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.speed	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Analyzing/heptan/pre/BondFragment01/pcp.speed	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,13 @@
+
+MaxG[] = nA nA nA -> N[] = nA nA nA
+LevNo   MaxG    RMaxG   MaxN    N[0]    N[1]    N[2]    RLevSStep
+0       5147691 10295381        25165824        384     256    256     0
+1       643665  1287329 3145728 192     128     128     267
+2       80442   160883  393216  96      64      64      267
+3       10074   20147   49152   48      32      32      333
+4       1264    2527    6144    24      16      16      862
+procs   proc[0] proc[1] PsiMax  PsiDoub PsiUp   PsiDown NRStep  TotalIons
+1       1       1       $Psi    $Psi+0    0+0     0+0     1       $nr
+Types	mpqc	  calc	    compute gradient	      nuc rep	      one electron gradient	      overlap gradient	      two electron gradient	        contribution	          start thread	          stop thread	        setup	    vector	      density	      evals	      extrap	      fock	        accum	        aogmat	          start thread	          stop thread	        init pmax	        local data	        setup	        sum	
+CPU	1.14	0.06	0.02	0.00	0.00	0.00	0.02	0.02	0.02	0.00	0.00	0.04	0.00	0.00	0.00	0.02	0.00	0.02	0.02	0.00	0.00	0.00	0.00	0.00	
+Wall	1.34	0.10	0.02	0.00	0.00	0.00	0.02	0.02	0.02	0.00	0.00	0.07	0.00	0.00	0.01	0.03	0.00	0.03	0.03	0.00	0.00	0.00	0.00	0.00	