Index: tests/regression/Molecules/8/post/test-rotated-xYz20.xyz
===================================================================
--- tests/regression/Molecules/8/post/test-rotated-xYz20.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
+++ tests/regression/Molecules/8/post/test-rotated-xYz20.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	8.35684	1.92717	6.65103
+H	6.63234	2.36823	6.65103
+H	7.80647	3.36711	7.54093
+H	8.88759	4.00235	5.4017
+H	7.1631	4.44342	5.40171
+H	7.80645	3.36705	3.26256
+H	8.35682	1.92714	4.15253
+H	6.63233	2.3682	4.15254
+C	7.65052	2.75737	6.65102
+C	7.86942	3.61321	5.40172
+C	7.65051	2.75734	4.15253
Index: tests/regression/Molecules/8/post/test-rotated-z180.xyz
===================================================================
--- tests/regression/Molecules/8/post/test-rotated-z180.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
+++ tests/regression/Molecules/8/post/test-rotated-z180.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	-7.64281	-2.64592	2.28661
+H	-9.42281	-2.64589	2.28661
+H	-8.53283	-3.90457	1.39672
+H	-7.64284	-4.7879	3.53594
+H	-9.42284	-4.78788	3.53594
+H	-8.53283	-3.90451	5.67509
+H	-7.64281	-2.64589	4.78511
+H	-9.42281	-2.64586	4.78511
+C	-8.53282	-3.27521	2.28662
+C	-8.53283	-4.15859	3.53593
+C	-8.53282	-3.27517	4.78512
Index: tests/regression/Molecules/8/post/test-rotated-z360.xyz
===================================================================
--- tests/regression/Molecules/8/post/test-rotated-z360.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
+++ tests/regression/Molecules/8/post/test-rotated-z360.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	9.42281	2.64589	4.78517
+H	7.64281	2.64592	4.78517
+H	8.53283	3.90457	5.67506
+H	9.42284	4.78788	3.53584
+H	7.64284	4.7879	3.53584
+H	8.53283	3.90451	1.39669
+H	9.42281	2.64586	2.28667
+H	7.64281	2.64589	2.28667
+C	8.53282	3.27521	4.78516
+C	8.53283	4.15859	3.53585
+C	8.53282	3.27517	2.28666
Index: tests/regression/Molecules/8/post/test-rotated-z90.xyz
===================================================================
--- tests/regression/Molecules/8/post/test-rotated-z90.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
+++ tests/regression/Molecules/8/post/test-rotated-z90.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	2.64589	-9.42281	4.78517
+H	2.64592	-7.64281	4.78517
+H	3.90457	-8.53283	5.67506
+H	4.78788	-9.42284	3.53584
+H	4.7879	-7.64284	3.53584
+H	3.90451	-8.53283	1.39669
+H	2.64586	-9.42281	2.28667
+H	2.64589	-7.64281	2.28667
+C	3.27521	-8.53282	4.78516
+C	4.15859	-8.53283	3.53585
+C	3.27517	-8.53282	2.28666
Index: tests/regression/Molecules/8/pre/test-rotated-xYz20.xyz
===================================================================
--- tests/regression/Molecules/8/pre/test-rotated-xYz20.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
+++ tests/regression/Molecules/8/pre/test-rotated-xYz20.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	9.00082	1.84611	5.02671
+H	8.52163	2.13043	6.71726
+H	9.80746	3.11525	5.979
+H	8.15645	4.09438	4.40925
+H	7.67726	4.3787	6.0998
+H	5.7441	3.62663	4.74123
+H	6.62788	2.14475	4.30388
+H	6.1487	2.42907	5.99442
+C	8.86174	2.60492	5.79677
+C	7.81634	3.61989	5.32974
+C	6.48881	2.90356	5.07393
Index: tests/regression/Molecules/8/pre/test-rotated-z180.xyz
===================================================================
--- tests/regression/Molecules/8/pre/test-rotated-z180.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
+++ tests/regression/Molecules/8/pre/test-rotated-z180.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	-9.78209	-2.64589	2.64589
+H	-9.78209	-2.64589	4.42589
+H	-10.672	-3.90454	3.53589
+H	-8.53279	-4.78789	2.64589
+H	-8.53279	-4.78789	4.42589
+H	-6.39363	-3.90454	3.53589
+H	-7.28359	-2.64589	2.64589
+H	-7.28359	-2.64589	4.42589
+C	-9.78209	-3.27519	3.53589
+C	-8.53279	-4.15859	3.53589
+C	-7.28359	-3.27519	3.53589
Index: tests/regression/Molecules/8/pre/test-rotated-z360.xyz
===================================================================
--- tests/regression/Molecules/8/pre/test-rotated-z360.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
+++ tests/regression/Molecules/8/pre/test-rotated-z360.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	9.78209	2.64589	2.64589
+H	9.78209	2.64589	4.42589
+H	10.672	3.90454	3.53589
+H	8.53279	4.78789	2.64589
+H	8.53279	4.78789	4.42589
+H	6.39363	3.90454	3.53589
+H	7.28359	2.64589	2.64589
+H	7.28359	2.64589	4.42589
+C	9.78209	3.27519	3.53589
+C	8.53279	4.15859	3.53589
+C	7.28359	3.27519	3.53589
Index: tests/regression/Molecules/8/pre/test-rotated-z90.xyz
===================================================================
--- tests/regression/Molecules/8/pre/test-rotated-z90.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
+++ tests/regression/Molecules/8/pre/test-rotated-z90.xyz	(revision 3273649ad568fc4313b80bd99826e13471458132)
@@ -0,0 +1,13 @@
+11
+	Created by molecuilder on Fri Aug  6 15:40:35 2010
+H	2.64589	-9.78209	2.64589
+H	2.64589	-9.78209	4.42589
+H	3.90454	-10.672	3.53589
+H	4.78789	-8.53279	2.64589
+H	4.78789	-8.53279	4.42589
+H	3.90454	-6.39363	3.53589
+H	2.64589	-7.28359	2.64589
+H	2.64589	-7.28359	4.42589
+C	3.27519	-9.78209	3.53589
+C	4.15859	-8.53279	3.53589
+C	3.27519	-7.28359	3.53589
Index: sts/regression/Molecules/8/pre/test.conf
===================================================================
--- tests/regression/Molecules/8/pre/test.conf	(revision 31db5bec2df65d790b2347935eb2728b268a6a52)
+++ 	(revision )
@@ -1,83 +1,0 @@
-# ParallelCarParinello - main configuration file - created with molecuilder
-
-mainname	pcp	# programm name (for runtime files)
-defaultpath	not specified	# where to put files during runtime
-pseudopotpath	not specified	# where to find pseudopotentials
-
-ProcPEGamma	8	# for parallel computing: share constants
-ProcPEPsi	1	# for parallel computing: share wave functions
-DoOutVis	0	# Output data for OpenDX
-DoOutMes	1	# Output data for measurements
-DoOutOrbitals	0	# Output all Orbitals
-DoOutCurr	0	# Ouput current density for OpenDx
-DoOutNICS	0	# Output Nucleus independent current shieldings
-DoPerturbation	0	# Do perturbation calculate and determine susceptibility and shielding
-DoFullCurrent	0	# Do full perturbation
-DoConstrainedMD	0	# Do perform a constrained (>0, relating to current MD step) instead of unconstrained (0) MD
-Thermostat	Berendsen	2.5	# Which Thermostat and its parameters to use in MD case.
-CommonWannier	0	# Put virtual centers at indivual orbits, all common, merged by variance, to grid point, to cell center
-SawtoothStart	0.01	# Absolute value for smooth transition at cell border 
-VectorPlane	0	# Cut plane axis (x, y or z: 0,1,2) for two-dim current vector plot
-VectorCut	0	# Cut plane axis value
-AddGramSch	1	# Additional GramSchmidtOrtogonalization to be safe
-Seed		1	# initial value for random seed for Psi coefficients
-
-MaxOuterStep	0	# number of MolecularDynamics/Structure optimization steps
-Deltat	0.01	# time per MD step
-OutVisStep	10	# Output visual data every ...th step
-OutSrcStep	5	# Output "restart" data every ..th step
-TargetTemp	0.000950045	# Target temperature
-MaxPsiStep	0	# number of Minimisation steps per state (0 - default)
-EpsWannier	1e-07	# tolerance value for spread minimisation of orbitals
-
-# Values specifying when to stop
-MaxMinStep	100	# Maximum number of steps
-RelEpsTotalE	1e-07	# relative change in total energy
-RelEpsKineticE	1e-05	# relative change in kinetic energy
-MaxMinStopStep	0	# check every ..th steps
-MaxMinGapStopStep	0	# check every ..th steps
-
-# Values specifying when to stop for INIT, otherwise same as above
-MaxInitMinStep	100	# Maximum number of steps
-InitRelEpsTotalE	1e-05	# relative change in total energy
-InitRelEpsKineticE	0.0001	# relative change in kinetic energy
-InitMaxMinStopStep	0	# check every ..th steps
-InitMaxMinGapStopStep	0	# check every ..th steps
-
-BoxLength			# (Length of a unit cell)
-20	
-0	20	
-0	0	20	
-
-ECut		128	# energy cutoff for discretization in Hartrees
-MaxLevel	5	# number of different levels in the code, >=2
-Level0Factor	2	# factor by which node number increases from S to 0 level
-RiemannTensor	0	# (Use metric)
-PsiType		0	# 0 - doubly occupied, 1 - SpinUp,SpinDown
-MaxPsiDouble	0	# here: specifying both maximum number of SpinUp- and -Down-states
-PsiMaxNoUp	0	# here: specifying maximum number of SpinUp-states
-PsiMaxNoDown	0	# here: specifying maximum number of SpinDown-states
-AddPsis		0	# Additional unoccupied Psis for bandgap determination
-
-RCut		20	# R-cut for the ewald summation
-StructOpt	0	# Do structure optimization beforehand
-IsAngstroem	1	# 0 - Bohr, 1 - Angstroem
-RelativeCoord	0	# whether ion coordinates are relative (1) or absolute (0)
-MaxTypes	2	# maximum number of different ion types
-
-# Ion type data (PP = PseudoPotential, Z = atomic number)
-#Ion_TypeNr.	Amount	Z	RGauss	L_Max(PP)L_Loc(PP)IonMass	# chemical name, symbol
-Ion_Type1	8	1	1.0	3	3	1.00800000000	Hydrogen	H
-Ion_Type2	3	6	1.0	3	3	12.01100000000	Carbon	C
-#Ion_TypeNr._Nr.R[0]    R[1]    R[2]    MoveType (0 MoveIon, 1 FixedIon)
-Ion_Type2_1	9.782085945	3.275186040	3.535886037	0 # molecule nr 0
-Ion_Type2_2	8.532785963	4.158586027	3.535886037	0 # molecule nr 1
-Ion_Type2_3	7.283585982	3.275186040	3.535886037	0 # molecule nr 2
-Ion_Type1_1	9.782085945	2.645886050	2.645886050	0 # molecule nr 3
-Ion_Type1_2	9.782085945	2.645886050	4.425886024	0 # molecule nr 4
-Ion_Type1_3	10.672039608	3.904536878	3.535886037	0 # molecule nr 5
-Ion_Type1_4	8.532785963	4.787886018	2.645886050	0 # molecule nr 6
-Ion_Type1_5	8.532785963	4.787886018	4.425886024	0 # molecule nr 7
-Ion_Type1_6	6.393632318	3.904536877	3.535886037	0 # molecule nr 8
-Ion_Type1_7	7.283585982	2.645886050	2.645886050	0 # molecule nr 9
-Ion_Type1_8	7.283585982	2.645886050	4.425886024	0 # molecule nr 10
Index: tests/regression/testsuite-molecules.at
===================================================================
--- tests/regression/testsuite-molecules.at	(revision 31db5bec2df65d790b2347935eb2728b268a6a52)
+++ tests/regression/testsuite-molecules.at	(revision 3273649ad568fc4313b80bd99826e13471458132)
@@ -61,9 +61,15 @@
 
 # 8. Rotate to PAS
-AT_SETUP([Molecules - BROKEN: Rotate to PAS])
+AT_SETUP([Molecules - Rotate to PAS])
 AT_KEYWORDS([Molecules])
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/8/pre/test.* .], 0)
-AT_CHECK([../../molecuilder -i test.conf -e ${abs_top_srcdir}/src/ --select-molecule-by-id 0 -m "0,0,1"], 0, [stdout], [stderr])
-#AT_CHECK([file=test.conf; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/8/post/$file], 0, [ignore], [ignore])
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/8/pre/test-*.xyz .], 0)
+AT_CHECK([../../molecuilder -i test-rotated-z90.xyz -e ${abs_top_srcdir}/src/ --select-molecule-by-id 0 -m "0,0,1"], 0, [stdout], [stderr])
+AT_CHECK([file="test-rotated-z90.xyz"; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/8/post/$file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i test-rotated-z180.xyz -e ${abs_top_srcdir}/src/ --select-molecule-by-id 0 -m "0,0,1"], 0, [stdout], [stderr])
+AT_CHECK([file="test-rotated-z180.xyz"; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/8/post/$file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i test-rotated-z360.xyz -e ${abs_top_srcdir}/src/ --select-molecule-by-id 0 -m "0,0,1"], 0, [stdout], [stderr])
+AT_CHECK([file="test-rotated-z360.xyz"; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/8/post/$file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i test-rotated-xYz20.xyz -e ${abs_top_srcdir}/src/ --select-molecule-by-id 0 -m "0,0,1"], 0, [stdout], [stderr])
+AT_CHECK([file="test-rotated-xYz20.xyz"; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/8/post/$file], 0, [ignore], [ignore])
 AT_CLEANUP
 